
#ifndef acknex_h	
#define acknex_h

#include <litec.h>
#include <compat.h>

typedef fixed var;
typedef fixed function;
typedef void action;	

#include <atypes.h>

#define EXT
#define F(f) f

#define afuncs_dll_h	
#include <afuncs.h>


var abs(var);
var acos(var);
var asin(var);
var atan(var);
var cos(var);
var sin(var);
var tan(var);
STRING* txt_str(TEXT*);

var wait(var);
STRING* inkey(STRING*);


#define set(obj,flag) obj.flags |= (flag)
#define reset(obj,flag) obj.flags &= ~(flag)
#define toggle(obj,flag) obj.flags ^= (flag)
#define is(obj,flag) (obj.flags & (flag))
#define wait_for(function) while (proc_status(function)) wait(1)
#define zero(ptr) memset((void*)&ptr,0,sizeof(ptr))
#define vec_zero(vec) ((var*)&(vec))[0] = 0; ((var*)&(vec))[1] = 0; ((var*)&(vec))[2] = 0
#define set_zero(ptr,len) memset((void*)&ptr,0,len)
#define _VAR(i) ((i)*1024)
#define _INT(i) ((i)/1024)


#define ENGINE_VAR		extern var
#define ENGINE_VECTOR	extern VECTOR
#define ENGINE_COLOR	extern COLOR
#define ENGINE_ANGLE	extern ANGLE
#define ENGINE_EVENT	extern EVENT
#define ENGINE_ENTITY	extern ENTITY*
#define ENGINE_STRING	extern STRING*
#define ENGINE_BMAP		extern BMAP*
#define ENGINE_VIEW		extern VIEW*
#define ENGINE_MATERIAL	extern MATERIAL*
#define ENGINE_CONTACT	    extern CONTACT*
#define ENGINE_			extern

int ackFirst;

#include <avars.h>


void ackStructs()
{
	VECTOR* v; v->x = 0;
	COLOR*	c; c->blue = 0;
	COLOR4*	c4; c4->blue = 0;
	ANGLE*	a; a->pan = 0;
	C_LINK*	cl; cl->index = 0;
	STRING*	s; s->length = 0;
	SOUND*	o; o->length = 0;
	BMAP*	b; b->width = 0;
	D3DVERTEX* d3dx; d3dx->x = 0;
	CONTACT*	x; x->x = 0;
	MATERIAL* m; m->power = 0;
	ENTITY*	e; e->x = 0;
	PARTICLE* p; p->x = 0;
	FONT*	f; f->dx = 0;
	TEXT*	t; t->layer = 0;
	PANEL*	pa; pa->layer = 0;
	VIEW*	v; v->layer = 0;
}


ENGINE_ENTITY my;
ENGINE_ENTITY your;

VECTOR* nullvector = { x=0; y=0; z=0; }
#endif