
#ifndef atypes_h
#define atypes_h

#define ON	1
#define OFF	0


#define FLAG1			(1<<0)	// flag1..flag8 for C-Script use
#define FLAG2			(1<<1)
#define FLAG3			(1<<2)
#define FLAG4			(1<<3)
#define FLAG5			(1<<4)
#define FLAG6			(1<<5)
#define FLAG7			(1<<6)
#define FLAG8			(1<<7)

#define INVISIBLE		(1<<8)
#define PASSABLE		(1<<9)
#define TRANSLUCENT		(1<<10)	
#define OVERLAY			(1<<12)	
#define ZNEAR			(1<<14)	
#define NOFILTER		(1<<16) 
#define UNLIT			(1<<17)	
#define SHADOW			(1<<18)	
#define LIGHT			(1<<19)	
#define NOFOG			(1<<20)	
#define BRIGHT			(1<<21)	
#define DECAL			(1<<22)	
#define METAL			(1<<22)	
#define CAST			(1<<23)	
#define POLYGON			(1<<26)	

#define NOSEND_TYPE		(1<<0)
#define NOSEND_SCALE	(1<<1)
#define NOSEND_ORIGIN	(1<<2)
#define NOSEND_ANGLES	(1<<3)
#define NOSEND_FRAME	(1<<4)
#define NOSEND_SKIN		(1<<5)
#define NOSEND_FLAGS	(1<<6)
#define NOSEND_AMBIENT	(1<<7)
#define NOSEND_ALPHA	(1<<8)
#define NOSEND_LIGHT	(1<<9)
#define NOSEND_COLOR	(1<<10)
#define NOSEND_UV		(1<<11)
#define NOSEND_SOUND	(1<<12)
#define NOSEND_ATTACH	(1<<13)
#define NOSEND			(1<<15)	
#define SEND_NOW		(1<<20)	


#define UNTOUCHABLE		(1<<0)	
#define SPOTLIGHT		(1<<1)
#define DIRECTIONAL		(1<<2)
#define SKY		        (1<<17)	
#define DOME			(1<<18)	
#define SCENE			(1<<19)	
#define CUBE			(1<<20)	
#define CYLINDER		(1<<21)	

// entity eflags
#define FAT				(1<<0)	
#define NARROW			(1<<1)	
#define PASS_TRANSP		(1<<7)	
#define PASS_BOTH		(1<<8)	
#define LOD0			(1<<16)	
#define LOD1			(1<<17)	
#define CLIPPED			(1<<21)	
#define ANIMATE			(1<<24)	
#define LOCAL			(1<<25)	


#define STREAK			(1<<8)
#define BEAM			(1<<9)
#define MOVE			(1<<11)

//event definitions
#define EVENT_BLOCK		1	
#define EVENT_ENTITY	2	
#define EVENT_STUCK		3	
#define EVENT_PUSH		4	
#define EVENT_IMPACT	5	
#define EVENT_FRICTION	6
#define EVENT_DETECT	7
#define EVENT_SCAN		8
#define EVENT_SHOOT		9
#define EVENT_TRIGGER	10
#define EVENT_SONAR		11
#define EVENT_FRAME		12

#define EVENT_RECEIVE	13	
#define EVENT_DISCONNECT 20	

#define EVENT_CLICKUP	14	
#define EVENT_BUTTONUP	15	
#define EVENT_TOUCH		16	
#define EVENT_RELEASE	17	
#define EVENT_CLICK		18	
#define EVENT_RIGHTCLICK 19	
#define EVENT_JOIN		32	
#define EVENT_LEAVE		33	
#define EVENT_STRING	34	
#define EVENT_DATA		36	
#define EVENT_VAR		37	

#define DYNAMIC			(1<<0)
#define ENABLE_BLOCK	(1<<EVENT_BLOCK)
#define ENABLE_ENTITY	(1<<EVENT_ENTITY)
#define ENABLE_STUCK	(1<<EVENT_STUCK)
#define ENABLE_PUSH		(1<<EVENT_PUSH)
#define ENABLE_IMPACT	(1<<EVENT_IMPACT)
#define ENABLE_FRICTION (1<<EVENT_FRICTION)
#define ENABLE_DETECT	(1<<EVENT_DETECT)
#define ENABLE_SCAN		(1<<EVENT_SCAN)
#define ENABLE_SHOOT	(1<<EVENT_SHOOT)
#define ENABLE_TRIGGER	(1<<EVENT_TRIGGER)
#define ENABLE_SONAR	(1<<EVENT_SONAR)

#define ENABLE_FRAME	(1<<EVENT_FRAME)
#define ENABLE_RECEIVE	(1<<EVENT_RECEIVE)
#define ENABLE_DISCONNECT (1<<EVENT_DISCONNECT)

#define ENABLE_BUTTONUP	(1<<EVENT_BUTTONUP)
#define ENABLE_TOUCH	(1<<EVENT_TOUCH)
#define ENABLE_RELEASE	(1<<EVENT_RELEASE)
#define ENABLE_CLICK	(1<<EVENT_CLICK)
#define ENABLE_RIGHTCLICK (1<<EVENT_RIGHTCLICK)

#define IGNORE_ME 		(1<<0)
#define IGNORE_YOU		(1<<1)
#define IGNORE_PASSABLE (1<<2)
#define IGNORE_PASSENTS (1<<3)
#define IGNORE_MODELS	(1<<4)
#define IGNORE_SPRITES	(1<<5)
#define IGNORE_CONTENT  (1<<6)
#define IGNORE_MAPS		(1<<7)
#define IGNORE_WORLD	(1<<8)
#define IGNORE_PUSH		(1<<9)
#define ACTIVATE_SHOOT	(1<<10)
#define ACTIVATE_SONAR	(1<<11)
#define ACTIVATE_TRIGGER (1<<12)
#define USE_BOX			(1<<13)
#define GET_HITVERTEX	(1<<14)
#define ACTIVATE_PUSH	(1<<14)
#define USE_AXIS		(1<<15)
#define USE_AXISR		(1<<16)
#define SCAN_TEXTURE	(1<<16)
#define USE_AABB		(1<<17)
#define GLIDE			(1<<18)
#define USE_POLYGON		(1<<19)
#define IGNORE_FLAG2	(1<<21)


#define SCAN_ENTS		(0<<14)
#define SCAN_PATHS		(2<<14)
#define SCAN_NODES		(3<<14)
#define SCAN_POS		(4<<14)
#define SCAN_LIGHTS		(5<<14)
#define SCAN_LIMIT		(1<<18)

#define SV_VARS			(1<<0)
#define SV_INFO			(1<<1)
#define SV_STRINGS		(1<<2)
#define SV_POINTERS		(1<<3)
#define SV_BMAPS		(1<<4)
#define SV_FUNCTIONS	(1<<5)
#define SV_KEYS			(1<<6)
#define SV_LEVEL		(1<<7)
#define SV_SKY			(1<<8)
#define SV_VIEWS		(1<<9) 
#define SV_PANELS		(1<<10)
#define SV_SYS			(1<<12)
#define SV_MATERIAL		(1<<13) 
#define SV_PATH			(1<<14) 
#define SV_STRUCT		(1<<15) 
#define SV_PHYSICS		(1<<17)
#define SV_ALL			0x000FFFFF

#define TANGENT			(1<<16)
#define ENABLE_RENDER	(1<<17)	
#define ENABLE_VIEW		(1<<18)
#define ENABLE_TREE		(1<<19)	
#define OVERRIDE		(1<<22)	
#define AUTORELOAD		(1<<24)	

#define BMPF_ARGB		(1<<8)	
#define BMPF_SAVE		(1<<9)	
#define BMPF_MIPMAPS	(1<<10) 


#define STRF_SAVE       (1<<0)  
#define STRF_CONST      (1<<2)  

#define CENTER_X		(1<<8)  
#define CENTER_Y		(1<<9)  
#define CONDENSED		(1<<13) 
#define VISIBLE			(1<<14) 
#define OUTLINE			(1<<15)	
#define FILTER			(1<<20) 


#define PROCESS_TARGET	(1<<3)	
#define PROCESS_SCREEN	(1<<4)	
#define PROCESS_STENCIL	(1<<5)	
#define ISOMETRIC		(1<<7)  
#define PORTALCLIP		(1<<8)  
#define CHILD		    (1<<11) 
#define NOSHADER		(1<<12) 
#define NOLOD		    (1<<13) 
#define AUDIBLE			(1<<15) 
#define WIREFRAME		(1<<16)	
#define CULL_CW			(1<<17) 
#define NOCULL			(1<<19) 
#define NOCAST			(1<<20) 
#define NOFLAG1			(1<<21) 
#define NOSHADOW		(1<<22) 
#define NOPARTICLE		(1<<24) 
#define CONNECT_SERVER	1
#define CONNECT_CLIENT	2

#define SEND_VEC		1
#define SEND_ALL		2
#define SEND_RATE		4
#define SEND_UNRELIABLE	8


#define ANM_CYCLE		(1<<0)
#define ANM_ADD			(1<<1)
#define ANM_SKIP		(1<<2)

#define PH_RIGID		1		
#define PH_WAVE			2		
#define PH_BOX			0
#define PH_SPHERE		1
#define PH_CYLINDER		2
#define PH_POLY			3
#define PH_BALL			1
#define PH_HINGE		2
#define PH_SLIDER		3
#define PH_WHEEL		4


#define RUN_SCRIPT		1
#define RUN_LEVEL		2
#define RUN_ENT			3
#define RUN_SKY			4
#define RUN_MEDIA		5


#define PROC_EARLY		(1<<0)
#define PROC_LATE		(1<<1)


#define PAD_STRING 8 
#define PAD_SOUND 0
#define PAD_BMAP 60
#define PAD_MATERIAL 364
#define PAD_ENTITY 792
#define PAD_PARTICLE 0
#define PAD_FONT 64
#define PAD_TEXT 16
#define PAD_PANEL 24
#define PAD_VIEW 72

#define HBYTE_STRING 2 
#define HBYTE_ENTITY 4
#define HBYTE_ENTITY_LOCAL 5
#define HBYTE_ENTITY_LAYER 8
#define HBYTE_FONT 11
#define HBYTE_BMAP 12
#define HBYTE_MATERIAL 13
#define HBYTE_SOUND 14
#define HBYTE_TEXT 20
#define HBYTE_PANEL 21
#define HBYTE_VIEW 22
#define HBYTE_PARTICLE 23



typedef struct {
	var	x,y,z;
} VECTOR;

typedef struct {
	var	blue,green,red;
} COLOR;

typedef struct {
	var blue,green,red,alpha;
} COLOR4;

typedef struct {
	var pan,tilt,roll;
} ANGLE;

typedef struct C_LINK {
	long	index;		
	struct C_LINK *next; 
	char	*name;		
} C_LINK;				

typedef byte* EVENT;	

typedef struct STRING {
	C_LINK	link;
	char	*chars;		
	long	length;		
	long	flags;		
    byte    pad[PAD_STRING];
} STRING;

typedef struct SOUND {
	C_LINK	link;
	long 	length;
	byte	*buffer;
	long	type;		
} SOUND;

typedef struct BMAP {
	C_LINK	link;
	long 	width,height; 
	long	bytespp;	
	void	*ptr;		
	byte	*pixels;	
	long	flags;      
	void	*d3dtex;	
    byte    pad[PAD_BMAP];
} BMAP;

typedef struct {
	float x,y,z;	
	float nx,ny,nz;	
	float u1,v1;    
	float u2,v2;    
	float x3,y3,z3,w3; 
} D3DVERTEX;

#define D3DFVF_D3DVERTEX (D3DFVF_XYZ | D3DFVF_NORMAL | D3DFVF_TEX3 | D3DFVF_TEXCOORDSIZE2(0) | D3DFVF_TEXCOORDSIZE2(1) | D3DFVF_TEXCOORDSIZE4(2))

typedef struct MATERIAL {	
	C_LINK	link;
	var		ambient_blue,ambient_green,ambient_red;
	var		diffuse_blue,diffuse_green,diffuse_red;
	var		specular_blue,specular_green,specular_red;
	var		emissive_blue,emissive_green,emissive_red;
	var		map_blue,map_green,map_red;
	var		alpha;
	var		power;		
	var		albedo;
	var		scale1,scale2;
	var		cycle;
	var		skill[20];
	float	matrix[16];
	long	flags;
	char	*effect;
	long	unused;
	BMAP	*skin1,*skin2,*skin3,*skin4;
	EVENT	event;		
    byte    pad[PAD_MATERIAL];
} MATERIAL;

typedef struct ENTITY {
	C_LINK	link;
	char	*type;		
	var		x,y,z;		
	var		pan,tilt,roll;	
	var		scale_x,scale_y,scale_z;	
	long	flags;		
	var		frame;		
	var		nextframe;	
	var		skin;		
	var		ambient;	
	var		albedo;		
	var		alpha;		
	var		lightrange;	
	var		blue,green,red;	
	long	emask;		
	long	eflags;		
	var		min_x,min_y,min_z;
	var		max_x,max_y,max_z;	
	var		trigger_range;
	var		push;
	var		floor_dist; 
	long	smask;		
	var 	client_id;	
						
	var		skill[100];	
	var		pose;		
	MATERIAL* material;	
	long	intern1;	
	long	flags2;		
	char	*attachname;	
	EVENT	event;		
	EVENT	local;		
	var		layer;		
	long	intern2;
	char	*string1,*string2;	
	long	intern3[4];
	struct ENTITY*	parent;
} ENTITY;

typedef struct PARTICLE {
	C_LINK	link;
	var		lifespan;	
	var		x,y,z;		
	var		vel_x,vel_y,vel_z;	
	var		size;		
	BMAP	*bmap;		
	EVENT	event;		
	long	flags;		
	var		skill_x,skill_y,skill_z; 
	var		gravity;
	var		angle;		
	var		alpha;		
	ENTITY	*creator;	
	var		blue,green,red;
	var		skill[4];	
    void*   d3dmesh;    
    MATERIAL* material; 
} PARTICLE;

typedef struct CONTACT {
	D3DVERTEX *v;       
	var		x,y,z;     
	var		nx,ny,nz;   
	var		u1,v1;      
	var		u2,v2;     
	var		vertex;	    
    var     triangle;   
    var     chunk;       
    void*   model;      
    var     light;
    var     alpha;
	var		blue,green,red; 
	long	flags;	    
    ENTITY* entity;     
	BMAP	*skin1,*skin2,*skin3,*skin4;  
    char*   texname;    
} CONTACT;

#define HIT_BLOCK   (1<<9)
#define HIT_ENTITY  (1<<10)
#define HIT_TARGET (hit.flags & (HIT_BLOCK | HIT_ENTITY))

typedef struct FONT {
	C_LINK	link;
	int		dx,dy;		
	int		num;		
	int		cpl;		
	char	*type;		
	BMAP	bmap;		
    byte    pad[PAD_FONT];
} FONT;

typedef struct TEXT {
	C_LINK	link;
	long	type;		
	var		layer;		
	var		pos_x,pos_y;	
	long	flags;		//
	var		alpha;		
	var		offset_y;	
	var		size_y;		
	FONT*	font;		
	long	length;		
	STRING*	*pstring;	
	var		scale_x,scale_y;
	var		blue,green,red;	
	var		strings;	
	BMAP*	target_map;
} TEXT;

typedef struct PANEL {
	C_LINK	link;
	long	type;		
	var		layer;		
	var		pos_x,pos_y;	
	long	flags;		
	var		alpha;		
	BMAP	*bmap;		
	var		scale_x,scale_y;
	var		blue,green,red;	
	var		size_x,size_y;	
	var		angle;			
	var		center_x,center_y;	
	BMAP	*mouse_map;
	BMAP	*target_map;
	EVENT	event;		
} PANEL;

typedef struct VIEW {
	C_LINK	link;
	long	type;		
	var		layer;		
	var		pos_x,pos_y;	
	long	flags;		
	var		size_x,size_y;	
	var		x,y,z;		
	var		pan,tilt,roll;	
	var		offset_x,offset_y;	
	var		arc;		
	var		aspect;		
	var		ambient;	
	long	dwcolor;    
	var		alpha;		
	var		portal_x,portal_y,portal_z;	
	var		pnormal_x,pnormal_y,pnormal_z;
	var		fog_start,fog_end;	
	var		depth;      
	ENTITY *genius;		
	struct VIEW	*portal; 
	BMAP	*bmap;		
	var		clip_near,clip_far;
	MATERIAL *material;	
	struct VIEW	*stage; 
    byte    pad[PAD_VIEW];
} VIEW;

#endif //atypes.h
